%define common_name             rtai
%define branch_name             fusion
%define branch_version          0.7.5

%define module_name             %common_name-%branch_name
%define module_version          %branch_version
%define module_release          alt1

%define kversion                2.6.11
%define krelease                alt1
%define flavour                 rt26-up

%define alt_module_name		%module_name-%kversion-%flavour

%define base_arch %(echo %_target_cpu | sed 's/i.86/i386/;s/athlon/i386/')

%define module_dir /lib/modules/%kversion-%flavour-%krelease/%common_name
%define realtime_dir %_libdir/%common_name/%kversion-%flavour

Name: kernel-modules-%module_name-%flavour
Version: %module_version
Release: %module_release.1

Summary: The Real-Time Application Interface
License: GPL
Group: System/Kernel and hardware
URL: http://www.rtai.org

Packager: Kernel Maintainer Team <kernel@packages.altlinux.org>

Source1: config-%module_name-%module_version

ExclusiveOS: Linux
BuildRequires: make >= 3.80
BuildPreReq:   kernel-build-tools
BuildRequires: gcc-c++
BuildRequires: modutils
BuildRequires: kernel-headers-modules-%flavour = %kversion-%krelease
BuildRequires: kernel-source-%module_name = %module_version

Provides:  kernel-modules-%common_name-%kversion-%flavour-%krelease = %version-%release
Conflicts: kernel-modules-%common_name-%kversion-%flavour-%krelease < %version-%release
Conflicts: kernel-modules-%common_name-%kversion-%flavour-%krelease > %version-%release

Requires:  rtai-common >= 0.1
Requires:  dev >= 3.3.1-alt10
PreReq: coreutils
PreReq: modutils
PreReq: alternatives
PreReq: kernel-image-%flavour = %kversion-%krelease
Requires(postun): kernel-image-%flavour = %kversion-%krelease
ExclusiveArch: %ix86

%description
This package contains the RTAI (Real-Time Application Interface)
system and is intended for developers who are building embedded
systems that will run the Linux operating system. In fact, RTAI
is based on the Linux operating system to which it adds real-time
capabilities that are not natively supported since Linux is a
user-oriented operating system.

%package -n lib%module_name-%flavour
Version: %version
Release: %release
Summary: RTAI %branch_name %version for %kversion-%flavour library package
Group: System/Kernel and hardware
Requires: kernel-modules-%module_name-%flavour = %version-%release
Provides: lib%module_name

%description -n lib%module_name-%flavour
This package contains libraries for RTAI package:
 * kernel-modules-%module_name-%flavour

%package -n kernel-headers-%module_name-%flavour
Version: %version
Release: %release
Requires: kernel-headers-modules-%flavour = %kversion-%krelease
Requires: lib%module_name-%flavour = %version
Summary: RTAI %version for %kversion-%flavour development package
Group: System/Kernel and hardware

%description -n kernel-headers-%module_name-%flavour
RTAI (Real-Time Application Interface) adds real-time capabilities that
are not natively supported with Linux.

These are headers for building realtime applications with RTAI package

%prep
%setup -cT -n kernel-module-%module_name-%module_version
%__rm -rf kernel-source-%module_name-%module_version
%__tar -jxf %_usrsrc/kernel/sources/kernel-source-%module_name-%module_version.tar.bz2
%setup -cT -n kernel-module-%module_name-%module_version/kernel-module-%module_name-build

%build
. %_usrsrc/linux-%kversion-%flavour/gcc_version.inc

CONFIG_FILE=../kernel-source-%module_name-%module_version/arch/%base_arch/defconfig

%__cp -vf %SOURCE1 $CONFIG_FILE
%__subst 's@CONFIG_RTAI_INSTALLDIR[[:space:]]*=.*@CONFIG_RTAI_INSTALLDIR=\"%realtime_dir\"@g' $CONFIG_FILE
%__subst 's@CONFIG_RTAI_LINUXIR[[:space:]]*=.*@CONFIG_RTAI_LINUXDIR=\"%_usrsrc/linux-%kversion-%flavour\"@g' $CONFIG_FILE

RTAIVer=%flavour-%version-%release

echo "Building RTAI $RTAIVer"

%__make -f ../kernel-source-%module_name-%module_version/makefile oldconfig \
	confopts="--with-module-dir=%module_dir --with-linux-dir=%_usrsrc/linux-%kversion-%flavour" \
	CC=gcc-$GCC_VERSION CXX=g++-$GCC_VERSION

### Don't install devices (FIXME: needs configure adjusting)
%__subst 's@install-exec-local: devices@install-exec-local:@' GNUmakefile

### It's a hack too:), but a useful hack:
%__cmp -s .rtai_config %SOURCE1 || %__cp -vf .rtai_config %SOURCE1

%make_build

echo "RTAI built $RTAIVer"

%install
%make_install DESTDIR=%buildroot install

%__mkdir_p %buildroot%_altdir

cat >%buildroot%_altdir/%alt_module_name <<EOF
%_prefix/realtime	%realtime_dir			10
%_bindir/rtai-load	%realtime_dir/bin/rtai-load	%realtime_dir
%_bindir/rtai-info	%realtime_dir/bin/rtai-info	%realtime_dir
%_bindir/rtai-config	%realtime_dir/bin/rtai-config	%realtime_dir
%_bindir/rtai-test	%realtime_dir/bin/rtai-test	%realtime_dir
EOF

for i in `ls %buildroot%realtime_dir/lib` ; do
f=`basename $i`
cat >>%buildroot%_altdir/%alt_module_name <<EOF
%_libdir/$f	%realtime_dir/lib/$f	%realtime_dir
EOF
done

for i in `ls %buildroot%realtime_dir/include` ; do
f=`basename $i`
cat >>%buildroot%_altdir/%alt_module_name <<EOF
%_includedir/$f	%realtime_dir/include/$f	%realtime_dir
EOF
done

%post
%post_kernel_modules %kversion-%flavour-%krelease
%register_alternatives %alt_module_name

%postun
%unregister_alternatives %alt_module_name
%postun_kernel_modules %kversion-%flavour-%krelease

%add_findprov_lib_path %realtime_dir/lib
%add_findreq_skiplist %realtime_dir/bin/rtai-test
%add_findreq_skiplist %realtime_dir/bin/rtai-info

%files
%module_dir
%dir %realtime_dir/bin
%realtime_dir/bin/rtai-load
%realtime_dir/bin/rtai-info
%_altdir/%alt_module_name

%files -n lib%module_name-%flavour
%realtime_dir/lib/*.so.*

%files -n kernel-headers-%module_name-%flavour
%realtime_dir/bin/*
%realtime_dir/lib/*.so
%realtime_dir/lib/*.a
%realtime_dir/include
%realtime_dir/share
%realtime_dir/testsuite

%changelog
* Fri Jun 03 2005 Evgeny Sinelnikov <sin@altlinux.ru> 0.7.5-alt1.1
- Initial build for ALT Linux (rtai/fusion)
